if (!window.tvc) {
    window.tvc = {};
}
if (!window.tvc.createDocument) {
    window.tvc.createDocument = {};
}

tvc.createDocument = {

    fileDocumentInfo:"",
    parentId: "" ,
        beforeCheckinTicketService: function(options, payload, resolve, reject) {
            tvc.createDocument.parentId = payload[0];
            var inputElement = document.createElement("input");
            inputElement.type = "file";
            inputElement.accept = window.accept;
            inputElement.dispatchEvent(new MouseEvent("click"));
            inputElement.addEventListener('change', (event) => {
                event.preventDefault();
                event.stopImmediatePropagation();
                var files = event.target.files.length>0 ? event.target.files :event.dataTransfer.files;
                if (files.length>0) {
                    var file = files[0];
                    var documentInfo = {
                        title: file.name,
                        fileInfo: {
                        comments: '',
                      file: file
                    },
                    relInfo: {
                        parentId:tvc.createDocument.parentId,
                        parentRelName: 'PLMDocConnection',
                        parentDirection: 'from'
                    }
                    };
                tvc.createDocument.fileDocumentInfo = documentInfo;
                resolve(options);
                }
            });
        },
        
        csrfTokenName:"",
        csrfTokenValue:"",
        afterCheckinTicketService: function(response) {
            tvc.createDocument.csrfTokenName = response.csrf.name;
            tvc.createDocument.csrfTokenValue = response.csrf.value;
        },
        
        beforeCheckinService: function(payload, response,resolve, reject) {
            var fileInfo = tvc.createDocument.fileDocumentInfo.fileInfo; 
            var file = fileInfo && fileInfo.file;
            var fileName = file && fileInfo.file.name;
            file.type = 'overide/mimetype';
            var formData = new FormData();
            formData.append(
                Object.keys(JSON.parse(payload.body))[0],
                Object.values(JSON.parse(payload.body))[0]
            );
            formData.append('file_0', file, fileName);
            payload.data = formData;
            payload = {
                method: payload.method,
                url: payload.url,
                data: payload.data,
                contentType: false,
                processData: false
            };
            resolve(payload);
        },
        
        afterCheckinService: function(response) {
            response.text = encodeURI(response.text);
            response.csrfName = tvc.createDocument.csrfTokenName;
            response.csrfValue = tvc.createDocument.csrfTokenValue;
            response.parentId= tvc.createDocument.parentId;
            var fileInfo = tvc.createDocument.fileDocumentInfo.fileInfo;
            var file = fileInfo && fileInfo.file;
            var fileName = file && fileInfo.file.name;
            response.fileName = fileName;
            var d = new Date();
            var g = d.getTime();
            response.tempId = "temp_" + g;
        },

        beforeDocumentService: function(options, payload,resolve, reject) {
            resolve(options);
        },
        afterDocumentService: function(response) {
            // required empty function, should be solved/fixed by TVC-6639 
        } 
};
